﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
Sub Class_Globals
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
End Sub

' --------------------------------------------------------------------
' Copyright (c) 1998-2003 SoftSeguro, Lda
' Autor: Augusto Cavaleiro
' Propósito:
'   Encriptar e descriptar campos texto nas versões de 2003
' ---------------------- cls2004Criptar.CLS ----------------------------------
'
' Propriedades :
'       Texto as String     <- Texto descriptado
'       Cripta as String    -> Texto a descriptar
'       Valido as Boolean   -> Descriptação válida
'       MsgErro as String      -> Descriçã do Erro de descriptação
'
' Metodos:
'       DoEncrypta ( Text as String, Chave as String)
'                -> Encripta a Palavra fornecida como arg_1 e chave arg_2
'       DoDescrypta ( Criptado as String, Chave as String)
'                -> Descripta a Palavra fornecida como arg_1 e chave arg_2
'
Option Explicit
    
Private mvarChave As String
Private mvarSaltoInicial As Long
Private mvarSaltoFinal As Long
Private mvarTexto As String
Private mvarMsgErro As String
Private mvarValido As Integer
Private mvarCodSeguranca As String
'       0 - Ok
'       1 - Texto a encriptar vazio
'       2 - Codigo de Segurãnça inválido
'       3 - Inicialização (vazio)
'       4 - Texto de encriptação curto ( < 6 Chars )
'       5 - Encriptação inválida

Public Property Get CodigoInterno() As Long
    CodigoInterno = Val("" & mvarCodSeguranca)
End Property

Public Property Get CodigoSeguranca() As String
' Ler o texto resultante da descriptação
On Error GoTo Controlo
Dim X As Long

    X = Int(Val(mvarCodSeguranca) * Val(Right(mvarCodSeguranca, 2))) Mod 100000
    CodigoSeguranca = Right(mvarCodSeguranca, 3) & "-" & Format(X, "000000")
    Exit Property
Controlo:
    X = Int(Val(mvarCodSeguranca) / 2 * Val(Right(mvarCodSeguranca, 2))) Mod 100000
    CodigoSeguranca = Right(mvarCodSeguranca, 3) & "-" & Format(X, "000000")
    
End Property

Public Property Get Texto() As String
' Ler o texto resultante da descriptação
    Texto = mvarTexto
End Property

Public Property Get Cripta() As String
' Ler o texto resultande a encriptação
    Cripta = mvarTexto
End Property

Public Property Get MsgErro() As String
' Ler a descrição do erro
    Select Case mvarValido
        Case 0
            mvarMsgErro = ""
        Case 1
            mvarMsgErro = "Texto a encriptar vazio"
        Case 2
            mvarMsgErro = "Código de Segurãnça inválido"
        Case 3
            mvarMsgErro = "Inicialização(vazio)"
        Case 5
            mvarMsgErro = "Texto de encriptação curto < 6"
        Case 4
            mvarMsgErro = "Encriptação inválida"
            
    End Select
    MsgErro = mvarMsgErro

End Property

Public Property Get NumErro() As Integer
' Ler o número do erro
    
    NumErro = mvarValido
    
End Property

Public Property Get Valido() As Boolean
' Ler se existe erro ou não
    
    Valido = (mvarValido = 0)
    
End Property


Public Sub DoEncrypta(sText As String, sKeyString As String)
	' Encriptar texto com base numa chave
	mvarChave = LCase(Trim(sKeyString))
	mvarTexto = Trim(sText)
	If Len(mvarTexto) > 0 Then
		Initializa
		Encrypta
		FazTexto
		mvarValido = 0
	Else
		mvarValido = 1
	End If
End Sub

Public Sub DoDescrypta(sText As String, sKeyString As String)
	' Descriptar o texto
	mvarTexto = sText
	mvarChave = LCase(Trim(sKeyString))
	If Len(mvarTexto) > 0 Then
		Initializa
		DesFazTexto
		Descrypta
	Else
		mvarValido = 1
		mvarMsgErro = "Texto a encriptar vazio"
	End If
End Sub

Private Sub Encrypta()
	' Encripta o texto armazenado em mvarTexto
	Dim nC As Integer
	Dim nB As Integer
	Dim lI As Long
	Dim lNum As Long, lMax As Long, lTotal As Long
	Dim sChar As String
        
	' Determina o código de validação para a o texto a encriptar
	lTotal = 0
	For lNum = 1 To Len(mvarTexto)
		lTotal = lTotal + Asc(mId(mvarTexto, lNum, 1)) * (lNum Mod 13 + 1)
	Next lNum
       
	' Se o texto é não vazio então acrescenta ao texto o código de validação
	If Len(mvarTexto) > 0 Then
		mvarCodSeguranca = Format(lTotal, "000000000")
		mvarTexto = Format(lTotal, "000000000") & mvarTexto & Format(lTotal, "000000000")
	Else
		mvarCodSeguranca = "000000000"
	End If

	' Troca a ordem dos caracteres dentro da string
	lNum = 1
	lMax = Len(mvarTexto)
       
	While lNum < lMax
	sChar = mId(mvarTexto, lNum, 1)
	Mid(mvarTexto, lNum, 1) = mId(mvarTexto, lMax, 1)
	Mid(mvarTexto, lMax, 1) = sChar
	lNum = lNum + mvarSaltoInicial
	lMax = lMax - mvarSaltoInicial
	Wend
    
	' Troca a ordem dos caracteres dentro da string
	lNum = 1
	lMax = Len(mvarTexto)
       
	While lNum < lMax
	sChar = mId(mvarTexto, lNum, 1)
	Mid(mvarTexto, lNum, 1) = mId(mvarTexto, lMax, 1)
	Mid(mvarTexto, lMax, 1) = sChar
	lNum = lNum + mvarSaltoFinal
	lMax = lMax - mvarSaltoFinal
	Wend
       
	' Cripta o texto
	For lI = 1 To Len(mvarTexto)
		nC = Asc(mId(mvarTexto, lI, 1))
		' Salta um valores na sequência
		nB = Int(Rnd * 7)
		lNum = 40
		While nB > 0
		lNum = lNum + Int(Rnd * 7)
		nB = nB - 1
		Wend
        
		nB = Int(lNum + Rnd * 178)
		Mid(mvarTexto, lI, 1) = Chr(nC Xor nB)
	Next lI
       
End Sub

Private Sub Descrypta()
	' Descripta o texto armazenado em mvarTexto
	Dim nC As Integer
	Dim nB As Integer
	Dim lI As Long
	Dim lNum As Long, lMax As Long, lTotal As Long
	Dim sChar As String
	Dim sCodigoInicial As String
	Dim sCodigoFinal As String
	Dim TmpCodigo As String
       
	For lI = 1 To Len(mvarTexto)
		nC = Asc(mId(mvarTexto, lI, 1))
		' Salta um valores na sequência
		nB = Int(Rnd * 7)
		lNum = 40
		While nB > 0
		lNum = lNum + Int(Rnd * 7)
		nB = nB - 1
		Wend
		nB = Int(lNum + Rnd * 178)
		Mid(mvarTexto, lI, 1) = Chr(nC Xor nB)
	Next lI
       
	'Repor a ordem inicial dos caracteres
	lNum = 1
	lMax = Len(mvarTexto)
	While lNum < lMax
	sChar = mId(mvarTexto, lNum, 1)
	Mid(mvarTexto, lNum, 1) = mId(mvarTexto, lMax, 1)
	Mid(mvarTexto, lMax, 1) = sChar
	lNum = lNum + mvarSaltoFinal
	lMax = lMax - mvarSaltoFinal
	Wend
       
	'Repor a ordem inicial dos caracteres
	lNum = 1
	lMax = Len(mvarTexto)
	While lNum < lMax
	sChar = mId(mvarTexto, lNum, 1)
	Mid(mvarTexto, lNum, 1) = mId(mvarTexto, lMax, 1)
	Mid(mvarTexto, lMax, 1) = sChar
	lNum = lNum + mvarSaltoInicial
	lMax = lMax - mvarSaltoInicial
	Wend
       
	' Extrair do texto descriptado Codigo de Segurança
	If Len(mvarTexto) > 18 Then
		sCodigoFinal = Right(mvarTexto, 9)
		sCodigoInicial = left(mvarTexto, 9)
		mvarTexto = mId(mvarTexto, 10, Len(mvarTexto) - 18)
        
		' Recalcula o código de segurança
		lTotal = 0
		For lNum = 1 To Len(mvarTexto)
			lTotal = lTotal + Asc(mId(mvarTexto, lNum, 1)) * (lNum Mod 13 + 1)
		Next lNum
     
		' Verifica se o codigo de Segurança nao foi modificado
		' isto é valida a encriptação
		If Val(sCodigoFinal) = lTotal And sCodigoFinal = sCodigoInicial Then
			mvarValido = 0
			mvarMsgErro = ""
		Else
			TmpCodigo = lTotal
			If sCodigoInicial = mId(TmpCodigo, 1, Len(sCodigoInicial)) Then
				mvarValido = 0
				mvarMsgErro = ""
			Else
				mvarValido = 2
				mvarTexto = ""
			End If
		End If
	Else
		If Len(mvarTexto) = 0 Then
			sCodigoInicial = ""
			mvarValido = 0
			mvarMsgErro = ""
		Else
			sCodigoInicial = ""
			mvarValido = 4
			mvarMsgErro = "Texto de encriptação curto"
			mvarTexto = ""
		End If
	End If
	If mvarValido > 0 Then
		mvarTexto = ""
		mvarCodSeguranca = "000000000"
	Else
		mvarCodSeguranca = sCodigoFinal
	End If

End Sub

Private Sub FazTexto()
	' Transforma a encriptação em caracteres visiveis em campos de texto
	Dim nC As Integer
	Dim lI As Long
	Dim lJ As Long
	Dim nK As Integer
	Dim lA As Long
	Dim sB As String
	Dim lNum As Long, lMax As Long, lTotal As Long
	Dim sChar As String
       
	lA = Len(mvarTexto)
	sB = Space(lA + (lA + 2) \ 3)
	For lI = 1 To lA
		nC = Asc(mId(mvarTexto, lI, 1))
		lJ = lJ + 1
		Mid(sB, lJ, 1) = Chr((nC And 63) + 59)
		Select Case lI Mod 3
			Case 1
				nK = nK Or ((nC \ 64) * 16)
			Case 2
				nK = nK Or ((nC \ 64) * 4)
			Case 0
				nK = nK Or (nC \ 64)
				lJ = lJ + 1
				Mid(sB, lJ, 1) = Chr(nK + 59)
				nK = 0
		End Select
	Next lI
	If lA Mod 3 Then
		lJ = lJ + 1
		Mid(sB, lJ, 1) = Chr(nK + 59)
	End If
	mvarTexto = sB
       
	' Troca a ordem dos caracteres resultantes da encriptação
	lNum = 1
	lMax = Len(mvarTexto)
	While lNum < lMax
	sChar = mId(mvarTexto, lNum, 1)
	Mid(mvarTexto, lNum, 1) = mId(mvarTexto, lMax, 1)
	Mid(mvarTexto, lMax, 1) = sChar
	lNum = lNum + 1
	lMax = lMax - 1
	Wend

End Sub

Private Sub DesFazTexto()
	On Error GoTo Desfaz_erro
	' Transforma o texto encriptado visivel em texto real encriptado
	Dim nC As Integer
	Dim nD As Integer
	Dim nE As Integer
	Dim lA As Long
	Dim lB As Long
	Dim lI As Long
	Dim lJ As Long
	Dim lK As Long
	Dim sB As String
	Dim lNum As Long, lMax As Long
	Dim sChar As String
       
	' Recupera a ordem original dos caracteres
	lNum = 1
	lMax = Len(mvarTexto)
	While lNum < lMax
	sChar = mId(mvarTexto, lNum, 1)
	Mid(mvarTexto, lNum, 1) = mId(mvarTexto, lMax, 1)
	Mid(mvarTexto, lMax, 1) = sChar
	lNum = lNum + 1
	lMax = lMax - 1
	Wend
       
	lA = Len(mvarTexto)
	lB = lA - 1 - (lA - 1) \ 4
	sB = Space(lB)
	For lI = 1 To lB
		lJ = lJ + 1
		nC = Asc(mId(mvarTexto, lJ, 1)) - 59
		Select Case lI Mod 3
			Case 1
				lK = lK + 4
				If lK > lA Then lK = lA
				nE = Asc(mId(mvarTexto, lK, 1)) - 59
				nD = ((nE \ 16) And 3) * 64
			Case 2
				nD = ((nE \ 4) And 3) * 64
			Case 0
				nD = (nE And 3) * 64
				lJ = lJ + 1
		End Select
		Mid(sB, lI, 1) = Chr(nC Or nD)
	Next lI
       
	mvarTexto = sB
	Exit Sub
	Desfaz_erro:
	mvarValido = 5
	mvarMsgErro = "Encriptação inválida"
End Sub

Private Sub Initializa()
' Inicializa os números aleatórios numa sequência fixa e defenida
' pela chave
Dim nI As Integer, X As Double
        
mvarSaltoFinal = 0
mvarSaltoInicial = 0
Randomize Rnd(-1)